<script lang="ts" setup>
/* eslint-disable */
import { ref, onMounted, onBeforeUnmount, nextTick } from 'vue';
import { debounce } from 'lodash-es';
import { Close } from 'slippers-ui/icons';
import { search, SEARCH_TYPE, SearchBody } from '~/services/search.service';
import type { SearchData } from '@/types/navigation';

// Props
const props = defineProps<SearchData>();

// Emits
const emit = defineEmits<{
  (e: 'search', searchText: string): void;
  (e: 'suggestionSelect', suggestion: string): void;
}>();

// Reactive data
const searchText = ref('');
const suggestions = ref<Array<{ title: string }>>([]);
const searchType = SEARCH_TYPE.MARKETING;

// Debounced function
let suggestionDebounce: DebouncedFunc<() => void>;

const getSuggestions = () => {
  if (searchText.value.length < 3) {
    return;
  }

  const searchBody: SearchBody = new SearchBody({
    q: searchText.value,
    spelling: 'always',
    per_page: 10,
  });

  search(searchBody, searchType).then((res) => {
    suggestions.value = res.records.page;
    if (res.info.page.spelling_suggestion) {
      const spelling = { title: res.info.page.spelling_suggestion.text };
      suggestions.value = [spelling, ...suggestions.value];
    }
  });
};

suggestionDebounce = debounce(getSuggestions, 100);

// Methods
const onSuggestionSelect = (suggestion: string) => {
  searchText.value = suggestion;
  onSearch(suggestion);
};

const onSearch = (searchText: string) => {
  emit('search', searchText);
};

const cleanSearch = () => {
  searchText.value = '';
};

// Lifecycle hooks
onMounted(() => {
  nextTick(() => {
    const searchInput = document.querySelector('input[type="text"]') as HTMLInputElement;
    if (searchInput) searchInput.focus();
  });
});

onBeforeUnmount(() => {
  suggestionDebounce.cancel();
});
</script>

<template>
  <div class="be-nav-search-content">
    <div class="be-nav-search-content__input slp-mb-16">
      <input
        ref="searchInput"
        v-model="searchText"
        type="text"
        placeholder="Search"
        @keyup.enter="onSearch(searchText)"
        @input="suggestionDebounce"
      />
      <SlpIcon
        :icon="Close"
        size="md"
        v-if="searchText.length"
        class="be-nav-search-content__input--close"
        @click="cleanSearch"
      />
    </div>
    <div class="slp-mb-48">
      <SlpTypography class="slp-mb-8" tag="div" variant="body3">
        {{ props?.login?.text }}
        <a
          class="be-nav-search-content__link"
          :href="props?.login?.link.config.href"
          target="_blank"
          :data-ga-name="props?.login?.link.config.dataGaName"
          :data-ga-location="props?.login?.link.config.dataGaLocation"
          >{{ props?.login?.link.text }}</a
        >.
      </SlpTypography>
    </div>
    <NavigationSearchSuggestions
      :search-suggestions="suggestions"
      v-bind="props.suggestions"
      @suggestion-select="onSuggestionSelect"
    />
  </div>
</template>

<style lang="scss">
.be-nav-search-content {
  padding: $spacing-24;

  @media (max-width: $breakpoint-lg) {
    padding: $spacing-8;
  }

  &__input {
    width: 100%;
    position: relative;

    input {
      -webkit-appearance: none;
      -webkit-border-radius: 0;
      border-radius: 0;
      width: calc(100% - 8px);
      font-size: $text-heading-3;
      border: 0;
      border-bottom: $color-surface-300 solid 1px;
      color: $color-text-200;

      &::placeholder {
        color: $color-text-100;
      }

      &:focus {
        outline: none;
      }

      @media (max-width: $breakpoint-lg) {
        font-size: $text-heading-5-mobile;
        caret-color: $color-surface-700 !important;
      }
    }

    &--close {
      position: absolute;
      right: $spacing-16;
      top: 20px;
      cursor: pointer;

      @media (max-width: $breakpoint-lg) {
        top: 4px;
      }
    }
  }
  &__link {
    color: $color-primary-200 !important;
    font-weight: bold !important;
  }
}
</style>
